/*******************************************************************************
Copyright © 2024 Sebastian Roith

Licensed under CC BY 4.0. To view a copy of this license, visit http://creativecommons.org/licenses/by/4.0/
*******************************************************************************/

(function(window) {

const TABLES = [
    { "name": "RAUM", "primary": ["raumnr"], "table": [
        ["raumnr", "plaetze", "beamer", "baujahr"],
        ["A01", 28, 1, 1973],
        ["A02", 32, 0, 1973],
        ["A03", 32, 1, 1973],
        ["A04", 20, 1, 1999],
        ["A05", 18, 0, 1999],
        ["A06",  8, 0, 1999],
        ["A07", 32, 0, 1999],
        ["A08", 31, 1, 1973],
        ["A09", 26, 0, 1973],
        ["A10", 50, 1, 2019],
        ["A11", 30, 1, 2019]
    ] }
];

const LEVELS = [
    {
        "task": "<p>In der Tabelle <code>RAUM</code> sind Informationen zu Räumen abgespeichert.</p><p>Mache dich zunächst mit der Datenbanktabelle vertraut. Schreibe dazu zuerst eine Abfrage, die dir eine der Datenbanktabelle möglichst ähnliche Ergebnistabelle liefert. Führe sie aus und schaue dir die Ergebnistabelle genau an. Fülle dann einen Lückentext richtig aus.</p>",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "and", "max": 0, "fine": 0, "msg": "In dieser Teilaufgabe ist „AND“ noch nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "raumnr", "fine": 1, "msg": "Das erste Attribut muss „raumnr“ sein" },
            { "type": "attributeName", "index": 1, "value": "plaetze", "fine": 1, "msg": "Das zweite Attribut muss „plaetze“ sein" },
            { "type": "attributeName", "index": 2, "value": "beamer", "fine": 1, "msg": "Das dritte Attribut muss „beamer“ sein" },
            { "type": "attributeName", "index": 3, "value": "baujahr", "fine": 1, "msg": "Das vierte Attribut muss „baujahr“ sein" },
            { "type": "sameResult", "value": "SELECT * FROM RAUM", "fine": 1, "msg": "Die Ergebnistabelle dieser Abfrage entspricht nicht bestmöglich der Datenbanktabelle…" },
            { "type": "accept", "unlock": true }
        ],
        "questionWrongFine": 1,
        "question": {
            "html": "Fülle die Lücken richtig aus:",
            "choices": [
                { "selectalways": true, "html": "In ", "type": "number", "min": 0, "step": 1, "unit": " Räumen ist ein Beamer verbaut.", "accept": "6", "correct": true },
                { "selectalways": true, "html": "Am meisten Sitzplätze gibt es im Raum ", "type": "text", "unit": ".", "accept": "A10", "correct": true },
                { "selectalways": true, "html": "Der älteste Raum wurde  ", "type": "number", "min": 1900, "max": 2100, "step": 1, "accept": "1973", "unit": " gebaut.", "correct": true },
                { "selectalways": true, "html": "Es gibt ", "type": "number", "min": 0, "step": 1, "unit": " Räume.", "accept": "11", "correct": true }
            ]
        }
    },
    {
        "task": "<p>Du brauchst einen Raum mit Beamer, in dem mindestens 30 Personen einen Platz haben. Dafür kriegen wir doch sicher eine passende Abfrage hin.</p><p>Schreibe eine Abfrage, die alle Informationen über Räume mit Beamer liefert. Ob der Raum genug Plätze hat, musst du dann halt selbst prüfen.</p>",
        "code": "SELECT * FROM RAUM",
        "keepCode": true,
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "and", "max": 0, "fine": 0, "msg": "In dieser Teilaufgabe ist „AND“ noch nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "raumnr", "fine": 1, "msg": "Das erste Attribut muss „raumnr“ sein" },
            { "type": "attributeName", "index": 1, "value": "plaetze", "fine": 1, "msg": "Das zweite Attribut muss „plaetze“ sein" },
            { "type": "attributeName", "index": 2, "value": "beamer", "fine": 1, "msg": "Das dritte Attribut muss „beamer“ sein" },
            { "type": "attributeName", "index": 3, "value": "baujahr", "fine": 1, "msg": "Das vierte Attribut muss „baujahr“ sein" },
            { "type": "sameResult", "value": "SELECT * FROM RAUM WHERE beamer", "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "<p>Blöd, dass die Ergebnistabelle so viele Räume mit zu wenig Plätzen enthält. Vielleicht ist es anders herum besser:</p><p>Schreibe eine Abfrage, die alle Informationen über Räume mit mindestens 30 Sitzplätzen liefert. Dann musst du halt schnell manuell prüfen, ob ein Beamer vorhanden ist…</p>",
        "code": "SELECT * \n    FROM RAUM\n    WHERE beamer = 1",
        "keepCode": true,
        "readonly": false,
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "and", "max": 0, "fine": 0, "msg": "In dieser Teilaufgabe ist „AND“ noch nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "raumnr", "fine": 1, "msg": "Das erste Attribut muss „raumnr“ sein" },
            { "type": "attributeName", "index": 1, "value": "plaetze", "fine": 1, "msg": "Das zweite Attribut muss „plaetze“ sein" },
            { "type": "attributeName", "index": 2, "value": "beamer", "fine": 1, "msg": "Das dritte Attribut muss „beamer“ sein" },
            { "type": "attributeName", "index": 3, "value": "baujahr", "fine": 1, "msg": "Das vierte Attribut muss „baujahr“ sein" },
            { "type": "sameResult", "value": "SELECT * FROM RAUM WHERE plaetze > 30", "inverted": true, "fine": 1, "msg": "Genau 30 Plätze muss auch in die Ergebnistabelle" },
            { "type": "sameResult", "value": "SELECT * FROM RAUM WHERE plaetze >= 30", "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "<p>Was soll das?! Wir wollen doch nicht nur teilweise vorgefilterte Datentsätze selbst durchsuchen müssen. Das soll bitteschön das Datenbankmanagementsystem für uns erledigen!</p><p>Und das ist ja auch problemlos möglich. Nämlich so, wie nachfolgend gezeigt. Probiere diese Abfrage aus und beantworte dann die Frage:</p>",
        "code": "SELECT *\n    FROM RAUM\n    WHERE beamer = 1 AND plaetze >= 30",
        "readonly": true,
        "tables": TABLES,
        "locked": true,
        "checkCode": [],
        "checkTermination": [
            { "type": "accept", "unlock": true }
        ],
        "questionWrongFine": 1,
        "question": {
            "html": "Welche der nachfolgenden Aussagen ist für diese Abfrage korrekt? Kreuze an und ergänze die Lückeninhalte:",
            "choices": [
                { "html": "Die Abfrage enthält ", "type": "number", "min": 0, "step": 1, "unit": " Gleichung(en) bzw. Ungleichung(en).", "accept": "2", "correct": true },
                { "html": "(Un-)Gleichungen sind mit dem Schlüsselwort ", "type": "text", "casesensitive": false, "unit": " verknüpft.", "accept": "AND", "correct": true },
                { "html": "Statt <code>=</code>, <code>&lt;</code>, <code>&lt;=</code>, enthält eine (Un-)Gleichung einen anderen Vergleichsoperator, nämlich ", "type": "text", "casesensitive": false, "unit": "." },
                { "html": "Die Abfrage enthält eine Vorgabe für die Sortierung" },
                { "html": "Vorkommende (Un-)Gleichung(en) sind komplexer als in früher gezeigten Abfragen" }
            ]
        }
    },
    {
        "task": "<p>Zwei Auswahlbedingungen kannst du also mit dem Schlüsselwort <code>AND</code> verknüpfen, wenn beide erfüllt sein müssen.</p><p>Und die beiden verknüpften Auswahlbedingungen sind zusammen eine Auswahlbedingung, die wiederum mittels <code>AND</code> mit einer weiteren Auswahlbedingung verknüpft werden kann. Probiere das gleich aus: Verändere die Abfrage so, dass die Ergebnistabelle alle gespeicherten Daten zu Räumen enthält, die einen Beamer haben, mindestens 30 Plätze <em>und die nach 1973 gebaut wurden</em>.</p>",
        "code": "SELECT *\n    FROM RAUM\n    WHERE beamer = 1 AND plaetze >= 30",
        "tables": TABLES,
        "locked": false,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 4, "fine": 1, "msg": "Alle Attribute sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "raumnr", "fine": 1, "msg": "Das erste Attribut muss „raumnr“ sein" },
            { "type": "attributeName", "index": 1, "value": "plaetze", "fine": 1, "msg": "Das zweite Attribut muss „plaetze“ sein" },
            { "type": "attributeName", "index": 2, "value": "beamer", "fine": 1, "msg": "Das dritte Attribut muss „beamer“ sein" },
            { "type": "attributeName", "index": 3, "value": "baujahr", "fine": 1, "msg": "Das vierte Attribut muss „baujahr“ sein" },
            { "type": "keyword", "value": "and", "min": 1, "fine": 1, "msg": "Ohne das Schlüsselwort „AND“ wirst du diese Teilaufgabe nicht lösen können…" },
            { "type": "keyword", "value": "and", "min": 2, "max": 2, "fine": 1, "msg": "Ohne genau zweimal das Schlüsselwort „AND“ wirst du diese Teilaufgabe nicht lösen können…" },
            { "type": "sameResult", "value": "SELECT * FROM RAUM WHERE beamer = 1 AND plaetze >= 30 AND baujahr > 1973", "fine": 1 },
            { "type": "and", "fine": 1, "msg": "Prüfe wirklich, ob das Baujahr größer als 1973 ist…", "value": [
                { "type": "compareQuery", "value": "<> 1973", "substring": true, "inverted": true },
                { "type": "compareQuery", "value": "1973 <>", "substring": true, "inverted": true }
            ] },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Alles Wesentliche gemerkt? Versuche jetzt, selbst eine SQL-Abfrage zu verfassen: Gesucht sind nur die Nummern aller Räume, in die 1999 gebaut wurden und die weniger als 20 Plätze bieten.",
        "code": "",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 1, "fine": 1, "msg": "Nur das Attribut „raumnr“ soll in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "raumnr", "fine": 1, "msg": "Das einzige Attribut muss „raumnr“ sein" },
            { "type": "keyword", "value": "and", "min": 1, "fine": 1, "msg": "Ohne das Schlüsselwort „AND“ wirst du diese Teilaufgabe nicht lösen können…" },
            { "type": "keyword", "value": "and", "max": 1, "fine": 1, "msg": "Ein einziges „AND“ reicht diesmal…" },
            { "type": "sameResult", "value": "SELECT raumnr FROM RAUM WHERE baujahr = 1999 AND plaetze < 20", "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Mit <code>AND</code> kannst du auch diese Aufgabe lösen: Wir brauchen eine Tabelle, die nur zuerst die Raumnummer und dann die Anzahl an Plätzen von allen Räumen enthält, die mindestens 18, aber höchstens 30 Plätze haben. Schreibe und teste eine passende SQL-Abfrage:",
        "code": "",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "between", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „BETWEEN“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 2, "fine": 1, "msg": "Nur „raumnr“ und „plaetze“ sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "raumnr", "fine": 1, "msg": "Das erste Attribut muss „raumnr“ sein" },
            { "type": "attributeName", "index": 1, "value": "plaetze", "fine": 1, "msg": "Das zweite Attribut muss „plaetze“ sein" },
            { "type": "keyword", "value": "and", "min": 1, "fine": 1, "msg": "Ohne das Schlüsselwort „AND“ wirst du diese Teilaufgabe nicht lösen können…" },
            { "type": "keyword", "value": "and", "max": 1, "fine": 1, "msg": "Ein einziges „AND“ reicht diesmal…" },
            { "type": "and", "fine": 1, "msg": "„mindestens“ und „höchstens“ schließt 18 und 30 mit ein", "value": [
                { "type": "sameResult", "value": "SELECT * FROM RAUM WHERE plaetze > 18 AND plaetze <= 30", "inverted": true },
                { "type": "sameResult", "value": "SELECT * FROM RAUM WHERE plaetze > 18 AND plaetze < 30", "inverted": true },
                { "type": "sameResult", "value": "SELECT * FROM RAUM WHERE plaetze >= 18 AND plaetze < 30", "inverted": true }
            ] },
            { "type": "sameResult", "value": "SELECT raumnr, plaetze FROM RAUM WHERE plaetze >= 18 AND plaetze <= 30", "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    },
    {
        "task": "Erst einmal was ganz anderes: Erinnerst du dich, was diese SQL-Abfrage bewirkt? Wenn nein, kannst du vor Beantwortung der Frage die Abfrage ausführen, das kostet jedoch einen Fehlerpunkt.",
        "code": "SELECT *\n    FROM RAUM\n    WHERE raumnr > 'A09'",
        "readonly": true,
        "tables": TABLES,
        "locked": false,
        "checkCode": [
            { "type": "accept", "fine": 1 }
        ],
        "checkTermination": [],
        "questionWrongFine": 1,
        "question": {
            "html": "Was bewirkt die Auswahlbedingung <code> raumnr &gt; 'A09'</code>?",
            "singlechoice": true,
            "choices": [
                { "html": "Bei alphabetischer Sortierung muss die Raumnummer <em>vor</em> „A09“ stehen" },
                { "html": "Bei alphabetischer Sortierung muss die Raumnummer <em>nach</em> „A09“ stehen", "correct": true },
                { "html": "Die Plätzeanzahl muss <em>größer</em> sein als bei „A09“" },
                { "html": "Die Plätzeanzahl muss <em>kleiner</em> sein als bei „A09“" },
                { "html": "Die Raumnummer muss <em>mehr</em> Buchstaben haben als „A09“" },
                { "html": "Die Raumnummer muss <em>weniger</em> Buchstaben haben als „A09“" }
            ]
        }
    },
    {
        "task": "Schreibe und teste nun eine Abfrage, die eine Ergebnistabelle liefert, in der für die Räume A03 bis A08 zuerst das Baujahr, dann die Raumnummer enthält.",
        "keepCode": true,
        "code": "SELECT *\n    FROM RAUM\n    WHERE raumnr > 'A09'",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "between", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „BETWEEN“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 2, "fine": 1, "msg": "Nur „baujahr“ und „raumnr“ sollen in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "baujahr", "fine": 1, "msg": "Das erste Attribut muss „baujahr“ sein" },
            { "type": "attributeName", "index": 1, "value": "raumnr", "fine": 1, "msg": "Das zweite Attribut muss „raumnr“ sein" },
            { "type": "keyword", "value": "and", "min": 1, "fine": 1, "msg": "Ohne das Schlüsselwort „AND“ wirst du diese Teilaufgabe nicht lösen können…" },
            { "type": "keyword", "value": "and", "max": 1, "fine": 1, "msg": "Ein einziges „AND“ reicht diesmal…" },
            { "type": "and", "fine": 1, "msg": "Auch die Räume A03 und A08 sollen in die Ergebnistabelle", "value": [
                { "type": "sameResult", "value": "SELECT baujahr, raumnr FROM RAUM WHERE raumnr >= 'A03' AND raumnr < 'A08'", "inverted": true },
                { "type": "sameResult", "value": "SELECT baujahr, raumnr FROM RAUM WHERE raumnr > 'A03' AND raumnr <= 'A08'", "inverted": true },
                { "type": "sameResult", "value": "SELECT baujahr, raumnr FROM RAUM WHERE raumnr > 'A03' AND raumnr < 'A08'", "inverted": true }
            ] },
            { "type": "sameResult", "value": "SELECT baujahr, raumnr FROM RAUM WHERE raumnr >= 'A03' AND raumnr <= 'A08'", "fine": 1 },
            { "type": "accept", "unlock": true }
        ]
    },

    {
        "task": "<p>Wie viele Plätze gibt es in Räumen mit Beamer, die weniger als 50 Plätze haben? Schreibe und teste eine Abfrage, die für diese Räume nur die Anzahl an Plätzen in die Ergebnistabelle übernimmt.</p>",
        "keepCode": true,
        "code": "SELECT baujahr, raumnr \n    FROM RAUM \n    WHERE raumnr >= 'A03' \n        AND raumnr <= 'A08'",
        "tables": TABLES,
        "locked": true,
        "checkCode": [
            { "type": "keyword", "value": "select", "max": 1, "fine": 0, "msg": "In dieser Aufgabe sind verschachtelte Abfragen nicht erlaubt…" },
            { "type": "keyword", "value": "as", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „AS“ nicht erlaubt…" },
            { "type": "keyword", "value": "or", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „OR“ nicht erlaubt…" },
            { "type": "keyword", "value": "not", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „NOT“ nicht erlaubt…" },
            { "type": "keyword", "value": "between", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „BETWEEN“ nicht erlaubt…" },
            { "type": "keyword", "value": "order", "max": 0, "fine": 0, "msg": "In dieser Aufgabe ist „ORDER BY“ nicht erlaubt…" }
        ],
        "checkTermination": [
            { "type": "attributeCount", "value": 1, "fine": 1, "msg": "Nur die Anzahl an Plätzen soll in der Ergebnistabelle stehen" },
            { "type": "attributeName", "index": 0, "value": "plaetze", "fine": 1, "msg": "Das einzige Attribut muss „plaetze“ sein" },
            { "type": "keyword", "value": "and", "min": 1, "fine": 1, "msg": "Ohne das Schlüsselwort „AND“ wirst du diese Teilaufgabe nicht lösen können…" },
            { "type": "keyword", "value": "and", "max": 1, "fine": 1, "msg": "Ein einziges „AND“ reicht diesmal…" },
            { "type": "sameResult", "value": "SELECT plaetze FROM RAUM WHERE beamer = 1 AND plaetze < 50", "fine": 1 },
            { "type": "compareQuery", "value": "'A10'", "substring": true, "inverted": true, "fine": 1, "msg": "Nur, weil zufälligerweise A10 der einzige Raum mit mindestens 50 Plätzen ist, darfst du das nicht verwenden…" },
            { "type": "accept", "unlock": true }
        ]
    }
];

window.sqlCodingTask = {
    levels: LEVELS
};
})(window);
